#include <sys/types.h>
#include <sys/stat.h>
/*
 * for the hash comparison #define MD5SUM
 */
#if defined(__CYGWIN__)
# include <cygwin/stat.h>
# define HASHCHAR	'*'
/*
 * the popen() is not supported in cygwin
 * for no hash comparison #undef MD5SUM
 */
#else
# if !defined(_AIX)
#  include <linux/stat.h>
# endif
# define HASHCHAR	' '
#endif
# define HASHSUM	1
# define SHA1SUM	"/usr/bin/sha1sum"
# define MD5SUM		"/usr/bin/md5sum"
# define CKSUM		"/usr/bin/cksum"
# define SUM		"/usr/bin/sum"
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#if !defined(_AIX)
#include <getopt.h>
#endif
#include <time.h>
#ifndef loff_t
#define loff_t off_t
#endif
#define	EMPTYSTRING	"                                                                "

typedef
struct dupinfo
{
	/* keep the file stat as delivered by lstat()	*/
	loff_t          size;
	/* keep file names for later reference	*/
	char**name;
	/*
		frdinfo[1].ident ----v	/----->	frdinfo[1].name
				 dupinfo[1]
		frdinfo[2].ident ----A	\----->	frdinfo[2].name
	 */
	struct dupinfo*replace;
} dinfo;

typedef
struct fileinfo
{
	/* remember the file name including path	*/
	char*name;
	/* keep the file stat as delivered by lstat()	*/
	struct stat info;
	/* keep the hash number for later comparison	*/
	char*hash;
	/* file system priority (= arg line position)	*/
	int  prio;
	dinfo *ident;
} frdinfo;

typedef struct termios TTY;

#define basename(x)	((strrchr((x),'/')!=NULL)?strrchr((x),'/')+1:(x)) 
#define S_IRWXUGO       (S_IRWXU|S_IRWXG|S_IRWXO)
#ifndef ALLPERMS
#define ALLPERMS        (S_IRWXUGO|S_ISUID|S_ISGID|S_ISVTX)
#endif
#define S_PERM(mode)    ((mode) & (ALLPERMS))

#include "version.h"
#define	MAXPATHLENGTH		4096
#define BLOCK			4096
#define INITIALFINFOCOUNT	20480
